<%@ Page Language="C#" AutoEventWireup="true" CodeFile="DataTableExample.aspx.cs" Inherits="DataTableExample" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Create and use a DataTable for data handling</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
    <h1>Create and use a DataTable for data handling</h1>
    A DataTable is a two-dimensional table with columns and rows that stores data temporary in memory. 
    A DataTable can be included in a DataSet or a DataView, a DataSet is
    a collection of many tables that can be related to each other. You are free to add
    columns and rows to a DataTable whenever you want and you can use a DataTable to
    do calculations and store the result in a new column. A DataTable can directly be
    used as a DataSource fr a Repeater, GridView, DataList or a DropDownList and you
    can use a DataTableReader to read data from a DataTable. A DataTable can also be
    used to insert data in a database when you want to insert many rows of data at the
    same time.<br />
    <br />
    In this example we use a DataTable that are created with a SqlDataAdapter in a query
    from a MS SQL database table to populate a repeater control, the DataTable are created
    in the HeadCategories class that are located in the "App_Code" folder. We are also
    creating a DataTable from a ASP.NET Table and are using this DataTable as input
    to insert many rows of data in a MS SQL database table.<br />
    <br />
    <asp:Button ID="btnSelectAllToDataTable" runat="server" Text="Select all to DataTable" Width="400px" OnClick="btnSelectAllToDataTable_Click" /><br /><br />

    <asp:Repeater ID="SelectAllRepeater" runat="server">
        <HeaderTemplate>
            <table border="0" width="600px" cellpadding="1" cellspacing="0" style="border: solid 1px silver">
                <tr>
                <th>Id</th>
                <th>Linkname</th>
                <th>Description</th>
                </tr>
        </HeaderTemplate>

        <ItemTemplate>
                <tr>
                <td><asp:Literal ID="HeadIdLiteral" runat="server" Text='<%#DataBinder.Eval(Container.DataItem, "HeadId")%>'></asp:Literal></td>
                <td><asp:Literal ID="LinkNameLiteral" runat="server" Text='<%#DataBinder.Eval(Container.DataItem, "LinkName")%>'></asp:Literal></td>
                <td><asp:Literal ID="DescriptionLiteral" runat="server" Text='<%#DataBinder.Eval(Container.DataItem, "Description")%>'></asp:Literal></td>
                </tr>
        </ItemTemplate>

        <FooterTemplate>
            </table>
        </FooterTemplate>
    </asp:Repeater><br />
    
    <h1>Add many headcategories in one SQL insert</h1>
    The HeadCategories class have one method that can be used to insert many headcategories at the same time. The method
    to insert many rows need a DataTable as a parameter and we therefore have to create a DataTable and send this to the
    method.<br />
    <br />
    <asp:TextBox ID="txtAddRows" runat="server" Text="1" Width="36px"></asp:TextBox>
    <asp:Button ID="btnAddRowsToTable" runat="server" Text="Add rows to the table" OnClick="btnAddRowsToTable_Click" /><br />
    <br />
    <asp:Table ID="ManyRowsTable" style="Width: 600px" runat="server">
        <asp:TableHeaderRow>
            <asp:TableHeaderCell>Linkname</asp:TableHeaderCell>
            <asp:TableHeaderCell>Description</asp:TableHeaderCell>
        </asp:TableHeaderRow>
        <asp:TableRow>
            <asp:TableCell><asp:TextBox ID="txtLinkName1" runat="server" Width="95%"></asp:TextBox></asp:TableCell>
            <asp:TableCell><asp:TextBox ID="txtDescription1" runat="server" Width="95%"></asp:TextBox></asp:TableCell>
        </asp:TableRow>
    </asp:Table>
    
    <br />
    <asp:Button ID="btnAddManyRows" runat="server" Text="Add many rows in one SQL insert" Width="400px" OnClick="btnAddManyRows_Click" /><br />
    <br />
    </div>
    </form>
</body>
</html>
